/* ======================================================================
**  TDictionary.cpp - Исходный файл модуля словаря.
**  Является частью программы Клёст-кроссворд, распространяемой под
**  Стандартной общественной лицензией, версии 2 (GNU GPL v2).
** ======================================================================
**  Copyleft 2009 - 2012 by Lab Free Technologies <admin@LabFreeTech.org>
** ==============================================================================
**  Copyleft 2009 - 2012 Лаборатория свободных технологий <admin@LabFreeTech.org>
** ==============================================================================
*/

#include "TDictionary.h"


TDictionary::TDictionary(QDialog *pwgt /* = 0*/): QDialog(pwgt),
    ui(new Ui::TDictionary)
{
    ui->setupUi(this);

    SaveState = true;

    connect(ui->pbAddWord, SIGNAL(clicked()), SLOT(slotAddRecord()));
    connect(ui->pbDeleteWord, SIGNAL(clicked()), SLOT(slotDelRecord()));
    connect(ui->pbMainTable, SIGNAL(clicked()), SLOT(slotMainTable()));
    //connect(b1, SIGNAL(clicked()), SLOT(slotb1()));
    connect(ui->pbSave, SIGNAL(clicked()), SLOT(slotbSave()));
    connect(ui->tvDictionary, SIGNAL(doubleClicked(QModelIndex)), SLOT(slotCellClicked()));
    CurrentTable = "w0";
    setWindowTitle(tr("Dictionary") + ": " + tr("Main table"));
}

TDictionary::~TDictionary()
{
    delete ui;
}

void TDictionary::slotCellClicked()
{
    //Словарь изменился
    SaveState = false;

    //При условии, что текущая таблица главная - открывается таблица, с выбранным количеством букв
    //- информация об количестве букв заносится в заголовок окна
    if(CurrentTable == "w0")
    {
        QString strWindowTitle;
        strWindowTitle.setNum(ui->tvDictionary->currentIndex().row() + 2);
        setWindowTitle(tr("Dictionary") + ": " + tr("Table") + " - " + strWindowTitle + tr(" letters"));
        CurrentTable = "w" + strWindowTitle;
        model2->setTable("w" + strWindowTitle);
        model2->select();
        model2->setEditStrategy(QSqlTableModel::OnManualSubmit);
    }

}

//Добавление записи в словарь
void TDictionary::slotAddRecord()
{
    QSqlQuery query1;
    QString str1, str2,
            strNumber,
            strCountLetter,
            NumberCurrentTable;
    int iNumberCurrentTable;
    bool bCurrenttTable;
    strNumber.setNum(tvDictionary->model()->rowCount() + 1);
    strCountLetter.setNum(tvDictionary->model()->rowCount() + 2);
    NumberCurrentTable.append(CurrentTable);
    NumberCurrentTable.replace("w", "");
    iNumberCurrentTable = NumberCurrentTable.toInt(&bCurrenttTable, 10);
    NumberCurrentTable.setNum(iNumberCurrentTable);
    if(CurrentTable == "w0")
        str1 = "INSERT INTO " + CurrentTable + "(Number, CountLetter, CountWord) VALUES("
                + strNumber + ", " +  strCountLetter + ", 0);";
    else
    {
        str1 = "INSERT INTO " + CurrentTable + " (Number) VALUES(" + strNumber + ");";
        str2 = "UPDATE w0 SET CountWord = " + strNumber + " WHERE CountLetter = " + NumberCurrentTable + ";";
        query1.exec(str2);
    }
    query1.exec(str1);
    model2->submitAll();
    /*str2.setNum(TableDictionary->currentIndex().row());
         setWindowTitle(str2);*/
}

//Возврат на главную таблицу
void TDictionary::slotMainTable()
{
    CurrentTable = "w0";
    setWindowTitle(tr("Dictionary") + ": " + tr("Main table"));
    model2->setTable("w0");
    model2->select();
    model2->setEditStrategy(QSqlTableModel::OnManualSubmit);
}

//Удаление записи из словаря
void TDictionary::slotDelRecord()
{
    QString str1, str2,
            strCurrent,
            strEnd,
            strCount,
            strNumber,
            strNumber2,
            strCountLetter,
            NumberCurrentTable;
    int iNumberCurrentTable;
    bool bCurrenttTable;
    QSqlQuery query1, query2;
    strCurrent.setNum(tvDictionary->currentIndex().row() + 1);
    strEnd.setNum(tvDictionary->model()->rowCount());
    strCount.setNum(tvDictionary->model()->rowCount() - 1);
    NumberCurrentTable.append(CurrentTable);
    NumberCurrentTable.replace("w", "");
    iNumberCurrentTable = NumberCurrentTable.toInt(&bCurrenttTable, 10);
    NumberCurrentTable.setNum(iNumberCurrentTable);
    if(tvDictionary->currentIndex().row() >= 0)
    {
        str1 = "DELETE FROM " + CurrentTable + " WHERE Number = " + strCurrent + ";";
        query1.exec(str1);

        if(CurrentTable == "w0")
            str1 = "SELECT Number, CountLetter FROM " + CurrentTable + ";";
        else
            str1 = "SELECT Number FROM " + CurrentTable + ";";
        query1.exec(str1);
        QSqlRecord rec1 = query1.record();
        int iNumber,
                iCountLetter,
                i = 1;

        while(query1.next())
        {
            str2.setNum(i);
            iNumber = query1.value(rec1.indexOf("Number")).toInt();
            iCountLetter = query1.value(rec1.indexOf("CountLetter")).toInt();
            strNumber.setNum(iNumber);
            strCountLetter.setNum(iCountLetter);
            strNumber2.setNum(i + 1);

            if(CurrentTable == "w0")
                str1 = "UPDATE " + CurrentTable + " SET Number = " + str2 +
                        " WHERE Number = " + strNumber + " AND CountLetter = " +
                        strCountLetter + ";";
            else
                str1 = "UPDATE " + CurrentTable + " SET Number = " + str2 +
                        " WHERE Number = " + strNumber + ";";
            query2.exec(str1);

            if(CurrentTable == "w0")
                str1 = "UPDATE " + CurrentTable + " SET CountLetter = " +
                        strNumber2 + " WHERE CountLetter = " + strCountLetter + ";";
            query2.exec(str1);
            i++;
            model2->submit();
            str1 = "UPDATE w0 SET CountWord = " + strCount + " WHERE CountLetter = " +
                    NumberCurrentTable + ";";
            query2.exec(str1);
        }
        // for(int i = 1; i <= TableDictionary->model()->rowCount(); i++)

    }
    else
    {
        str1 = "DELETE FROM " + CurrentTable + " WHERE Number = " + strEnd + ";";
        query1.exec(str1);
        str2 = "UPDATE w0 SET CountWord = " + strCount + " WHERE CountLetter = " +
                NumberCurrentTable + ";";
        query1.exec(str2);
        model2->submit();
    }
    model2->submitAll();
}

//Сохранение изменений в словарь
void TDictionary::slotbSave()
{
    model2->submitAll();
}

/*        void Dictionary::slotb1()
       {
//Создание структуры таблиц для словаря
        QSqlQuery query1;
        QString str1, strNum;
          for(int i = 2; i < 19; i++){
           //strNum.setNum(i);
           //str1 = "DROP TABLE w" + strNum;
           str1 = "CREATE TABLE w0 (Number INTEGER PRIMARY KEY NOT NULL, CountLetter INTEGER, CountWord INTEGER);";
           query1.exec(str1);
         }

//Добавление слов в словарь из текстовых файлов с кодировкой utf-8 и концом строки unix
        QSqlQuery query1;
         QString str1, str2;

         for(int i = 2; i < 19; i++)
          {
         str2.setNum(i);
         str1 = "CREATE TABLE w" + str2 + " (Number INTEGER PRIMARY KEY NOT NULL,"
                " Word VARCHAR(" + str2 + "),"
                " Interpretation VARCHAR(300));";

         query1.exec(str1);
         model2->setTable("w" + str2);
         model2->select();

          }
     QString sj;
           for(int j = 2; j <= 18; j++){
               sj.setNum(j);
 QFile ifile(QApplication::applicationDirPath() +  "/all-" + sj + ".txt");
 QTextStream sifile(&ifile);
 uchar cdata;
 ushort udata;
 QSqlQuery query1;
 bool bAdd;
 QString s, sWord, o, w, str1;
 QChar c;
 ifile.open(QIODevice::ReadOnly);
 qint64 isize, i;
 int k;
 i = 0;
 bAdd = false;
 isize = ifile.size();
   while(!sifile.atEnd())
    {
     //sifile >> cdata;
     //udata = ushort(cdata);
     //c = QChar(udata);
     sWord.append(sifile.readLine());
     s.append(sifile.readLine());
     str1 = "INSERT INTO w" + sj + " (Word, Interpretation) VALUES( '" + sWord + "' , '" + s + "');";
     query1.exec(str1);
     sWord.clear();
     s.clear();
     //i++;
    }
     str1 = "INSERT INTO w" + sj + " (Word, Interpretation) VALUES( '" + sWord + "' , '" + s + "');";
     query1.exec(str1);
    //s.setNum(i);
    //str1 = "UPDATE w0 SET CountWord = " + s + " WHERE CountLetter = " + sj + ";";
    //query1.exec(str1);
    //model2->submitAll();
    //s.clear();

   ifile.close();}
       }*/

