/* ======================================================================
**  TOptions.cpp - Исходный файл модуля формы свойств.
**  Является частью программы Клёст-кроссворд, распространяемой под
**  Стандартной общественной лицензией, версии 2 (GNU GPL v2).
** ======================================================================
**  Copyleft 2009 - 2012 by Lab Free Technologies <admin@LabFreeTech.org>
** ==============================================================================
**  Copyleft 2009 - 2012 Лаборатория свободных технологий <admin@LabFreeTech.org>
** ==============================================================================
*/

#include "TOptions.h"


TOptions::TOptions(QDialog *pwgt /* = 0*/): QDialog(pwgt),
    ui(new Ui::TOptions)
{
    ui->setupUi(this);

    connect(ui->bPathCrosswords, SIGNAL(clicked()), SLOT(slotSelectPathCrossword()));
    connect(ui->bPathTemplates, SIGNAL(clicked()), SLOT(slotSelectPathTemplates()));
    connect(ui->cbExport, SIGNAL(clicked()), SLOT(slotEnableTypeExport()));
}

TOptions::~TOptions()
{
    delete ui;
}

void TOptions::slotSelectPathCrossword()
{
    QString str = QFileDialog::getExistingDirectory(0, tr("Selection directory path of crosswords and exports."), ui->lePathCrossword->text());

    if(str != "") ui->lePathCrossword->setText(str);
}

void TOptions::slotSelectPathTemplates()
{
    QString str = QFileDialog::getExistingDirectory(0, tr("Selection directory path of templates"), ui->lePathTemplates->text());

    if(!str.isEmpty()) ui->lePathTemplates->setText(str);
}

void TOptions::slotEnableTypeExport()
{
    if(ui->cbExport->isChecked())
    {
        ui->cbTypeExport->setEnabled(true);
        ui->lTypeExport->setEnabled(true);
    }
    else
    {
        ui->cbTypeExport->setEnabled(false);
        ui->lTypeExport->setEnabled(false);
    }
}
