/* ======================================================================
**  TTemplateCrossword.cpp - Исходный файл модуля формы шаблонов кроссвордов.
**  Является частью программы Клёст-кроссворд, распространяемой под
**  Стандартной общественной лицензией, версии 2 (GNU GPL v2).
** ======================================================================
**  Copyleft 2009 - 2012 by Lab Free Technologies <admin@LabFreeTech.org>
** ==============================================================================
**  Copyleft 2009 - 2012 Лаборатория свободных технологий <admin@LabFreeTech.org>
** ==============================================================================
*/

#include "TTemplateCrossword.h"

TTemplateCrossword::TTemplateCrossword(QDialog *pwgt /*= 0*/): QDialog(pwgt),
    ui(new Ui::TTemplateCrossword)
{
    ui->setupUi(this);
}

TTemplateCrossword::~TTemplateCrossword()
{
    delete ui;
}

/*virtual void TemplateCrossword::mouseReleaseEvent(QMouseEvent* pe)
{
  QObject* Table1 = qobject_cast<QObject*>(sender());
  TableWidgetCrossword* Table2 = qobject_cast<TableWidgetCrossword*>(Table1->parent());
  Table2->setRowCount(5);
}*/

void TTemplateCrossword::InitForm()
{
    QBoxLayout* pbxLayout;
    QBoxLayout* pbxLayout2 = new QBoxLayout(QBoxLayout::TopToBottom);
    QBoxLayout* pbxLayout3 = new QBoxLayout(QBoxLayout::TopToBottom);
    QWidget* widget1;
    QDir dir;
    pbxLayout = new QBoxLayout(QBoxLayout::LeftToRight);
    uchar CountLayout;
    ushort TableWidth, TableHeight;
    TableWidth = 0;
    TableHeight = 0;
    TableCount = 0;
    uCurrentTable = 255;
    //Table = 0;
    widget1 = new QWidget;
    CountLayout = 0;

    //Загрузка всех файлов шаблонов из каталога Templates
    dir.setPath(FileOptions->sPathTemplate);

    foreach (QString strFileName, dir.entryList(QDir::Files))
    {

        if (strFileName.indexOf(".xwctpl") == -1) return;
        if (AddTableCrossword(strFileName) == NULL) return;

        Table[TableCount] = AddTableCrossword(strFileName);
        TableWidth = 0;
        TableHeight = 0;

        for(int i = 0; i < Table[TableCount]->columnCount(); i++)
            TableWidth += 8;

        for(int i = 0; i < Table[TableCount]->rowCount(); i++)
            TableHeight += 8;

        Table[TableCount]->setMinimumSize(TableWidth, TableHeight);

        if(strFileName != "")
        {
            if(CountLayout == 7)
            {
                pbxLayout2->addWidget(widget1, 0);
                widget1 = new QWidget;
                pbxLayout = new QBoxLayout(QBoxLayout::LeftToRight);
                CountLayout = 0;
            }

            pbxLayout->addWidget(Table[TableCount], 0);
            widget1->setLayout(pbxLayout);
            CountLayout++;
        }
        TableCount++;
    }

    //Создание размешения виджетов на форме
    pbxLayout2->addWidget(widget1, 0);
    widget1 = new QWidget;
    widget1->setLayout(pbxLayout2);
    ui->saCrossword->setWidget(widget1);
    ui->saCrossword->setBackgroundRole(QPalette::Dark);
    ui->saCrossword->setWidgetResizable(true);
    pbxLayout3->addWidget(ui->saCrossword, 0);
    pbxLayout3->addWidget(ui->bbCrossword, 0);
    setLayout(pbxLayout3);

    //Соединение, созданных таблиц со слотом изменения цвета при щелчке
    for(int i = 0; i < TableCount; i++)
        connect(Table[i], SIGNAL(CurrentTable()), SLOT(slotCurrentTable()));
}

//При щелчке по таблице, цвет изменяется с синего на чёрный у остальных таблиц, кроме выбранной
void TTemplateCrossword::slotCurrentTable()
{
    QBrush BrushBlue =  QBrush(Qt::blue, Qt::SolidPattern);
    QBrush BrushBlack = QBrush(Qt::black, Qt::SolidPattern);

    for(int i = 0; i < TableCount; i++)
    {
        for(int j = 0; j < Table[i]->rowCount(); j++)
        {
            for(int k = 0; k < Table[i]->columnCount(); k++)
                if(Table[i]->item(j ,k)->background() == BrushBlue)
                {
                    if(uCurrentTable == 255) uCurrentTable = i;

                    if(uCurrentTable != 255) break;
                }
            if(uCurrentTable != 255) break;
        }
        if(uCurrentTable != 255) break;
    }

    for(int i = 0; i < TableCount; i++)
    {
        for(int j = 0; j < Table[i]->rowCount(); j++)
        {
            for(int k = 0; k < Table[i]->columnCount(); k++)
                if(Table[i]->item(j ,k)->background() == BrushBlack)
                {
                    if(uCurrentTable == i) uCurrentTable = 255;

                    if(uCurrentTable == 255) break;
                }
            if(uCurrentTable == 255) break;
        }
        if(uCurrentTable == 255) break;
    }
    for(int i = 0; i < TableCount; i++)
    {
        if(i != uCurrentTable)
            for(int j = 0; j < Table[i]->rowCount(); j++)
                for(int k = 0; k < Table[i]->columnCount(); k++)
                    if(Table[i]->item(j ,k)->background() == BrushBlue)
                        Table[i]->item(j ,k)->setBackground(BrushBlack);
    }
}

//Добавление таблицы с шаблоном на форму
TTemplateGrid* TTemplateCrossword::AddTableCrossword(QString strFileName)
{
    FileName = FileOptions->sPathTemplate + "/" + strFileName;
    TTemplateGrid* TableCrossword;
    QTableWidgetItem* CellCrossword;
    QFile file(FileName);
    QByteArray baImport;
    file.open(QIODevice::ReadOnly);
    baImport = file.readAll();
    file.close();
    baImport = qUncompress(baImport);
    baImport = QByteArray::fromBase64(baImport);

    QTemporaryFile *tfCross = new QTemporaryFile;
    tfCross->open();
    tfCross->write(baImport);
    tfCross->flush();
    baImport.clear();
    file.setFileName(tfCross->fileName());
    QDataStream sfile(&file);
    file.open(QIODevice::ReadOnly);
    QBrush BrushBlack = QBrush(Qt::black, Qt::SolidPattern);
    QBrush BrushWhite = QBrush(Qt::white, Qt::SolidPattern);
    QFont TableFont;
    ushort idata;
    int IntCount;
    QString sappVersion;

    try
    {
        sfile >> sappVersion;

        if (sappVersion != QCoreApplication::applicationVersion()) throw TemplError::WrongFileFormat();
    }
    catch(TemplError::WrongFileFormat)
    {
        QMessageBox::warning(0, tr("Detection warning"), tr("Wrong file format!"));
        return NULL;
    }
    catch(...)
    {
        QMessageBox::critical(0, tr("Detection error"), tr("An unknown error occurred!"));
        return NULL;
    }

    sfile >> IntCount;
    TableCrossword = new TTemplateGrid;
    TableCrossword->horizontalHeader()->setVisible(false);
    TableCrossword->verticalHeader()->setVisible(false);
    TableCrossword->setRowCount(IntCount);
    sfile >> IntCount;
    TableCrossword->setColumnCount(IntCount);
    sfile >> IntCount;
    sfile >> TableFont;
    TableCrossword->setFont(TableFont);

    for(int i = 0; i < TableCrossword->rowCount(); i++)
        for(int j = 0; j < TableCrossword->columnCount(); j++)
        {
            CellCrossword = new QTableWidgetItem;
            TableCrossword->setItem(i,j,CellCrossword);
            TableCrossword->setRowHeight(i,7);
            TableCrossword->setColumnWidth(j,7);
            sfile >> idata;
            idata -= 1;

            if(QChar(idata) == 'b')
                TableCrossword->item(i,j)->setBackground(BrushBlack);
            else
                TableCrossword->item(i,j)->setBackground(BrushWhite);
        }

    file.close();
    tfCross->close();
    delete tfCross;
    return TableCrossword;
}
