/* ======================================================================
**  TTemplateCrossword.h - Заголовочный файл модуля формы шаблонов кроссвордов.
**  Является частью программы Клёст-кроссворд, распространяемой под
**  Стандартной общественной лицензией, версии 2 (GNU GPL v2).
** ======================================================================
**  Copyleft 2009 - 2012 by Lab Free Technologies <admin@LabFreeTech.org>
** ==============================================================================
**  Copyleft 2009 - 2012 Лаборатория свободных технологий <admin@LabFreeTech.org>
** ==============================================================================
*/

#ifndef TTEMPLATECROSSWORD_H
#define TTEMPLATECROSSWORD_H
#include "ui_TTemplateCrossword.h"
#include "../TTemplateGrid/TTemplateGrid.h"
#include <QtCore/QCoreApplication>
#include <QtCore/QString>
#include <QtCore/QDir>
#include <QtCore/QFile>
#include <QtCore/QDataStream>
#include <QtCore/QChar>
#include <QtCore/QTemporaryFile>
#include <QtGui/QBoxLayout>
#include <QtGui/QWidget>
#include <QtGui/QBrush>
#include <QtGui/QTableWidgetItem>
#include <QtGui/QFont>
#include <QtGui/QMessageBox>
#include "const.h"
#include "struct.h"
//#include "error.h"

class TemplError
{
  public:
        class WrongPassword {};
        class WrongFileFormat {};
};

namespace Ui {
class TTemplateCrossword;
}

class TTemplateCrossword : public QDialog, public Ui::TTemplateCrossword {
      Q_OBJECT

public:
       QString FileName;//Имя файла
       TTemplateGrid* Table[255];//Таблицы шаблонов
       uchar TableCount,//Количество таблиц
             uCurrentTable;//Текущая таблица
       TFileOptions *FileOptions;//Свойства файла

       explicit TTemplateCrossword(QDialog *pwgt = 0);
       ~TTemplateCrossword();

       Ui::TTemplateCrossword *ui;

private:

/*protected:
       virtual void mouseReleaseEvent  (QMouseEvent* pe);*/

public slots:
       void slotCurrentTable();//При щелчке по таблице с шаблоном кроссворда
       TTemplateGrid* AddTableCrossword(QString strFileName);//Добавление таблицы с шаблоном из заданного файла strFileName
       void InitForm();//Инициализация формы

};
#endif
