/* ======================================================================
**  const.h - Заголовочный файл констант кроссворда.
**  Является частью программы Клёст-кроссворд, распространяемой под
**  Стандартной общественной лицензией, версии 2 (GNU GPL v2).
** ======================================================================
**  Copyleft 2009 - 2012 by Lab Free Technologies <admin@LabFreeTech.org>
** ==============================================================================
**  Copyleft 2009 - 2012 Лаборатория свободных технологий <admin@LabFreeTech.org>
** ==============================================================================
*/

#ifndef CONST_H
#define CONST_H
#include <QtCore/QDir>

//Определение путей констант, в соответствии с системой
#if defined(Q_WS_WIN)

    #define PATH_SHARE_DOC QApplication::applicationDirPath()
    #define PATH_SHARE_APP QApplication::applicationDirPath()
    #define PATH_STAT QDir::homePath() + "/cstat.html"

#elif defined(Q_WS_X11)

    #define PATH_SHARE_DOC "/usr/share/doc/klest-crossword-1.0.0"
    #define PATH_SHARE_APP "/usr/share/klest-crossword-1.0.0"
    #define PATH_STAT QDir::homePath() + "/cstat.html"

#elif defined(Q_WS_MAC)

    #define PATH_SHARE_DOC QApplication::applicationDirPath()
    #define PATH_SHARE_APP QApplication::applicationDirPath()
    #define PATH_STAT QDir::homePath() +  "/cstat.html"

#endif

//Пути для разработки и отладки программы
/*#define PATH_SHARE_DOC QApplication::applicationDirPath()
#define PATH_SHARE_APP QApplication::applicationDirPath()
#define PATH_STAT QApplication::applicationDirPath() + "/cstat.html"*/

#define MODE_GUESSING true
#define MODE_EDITING false

#define ACROSS_ENABLE true
#define ACROSS_DISABLE false

#define LANGUAGE_RUSSIAN true
#define LANGUAGE_ENGLISH false

#define TOOLBAR_SHOW true
#define TOOLBAR_HIDE false

#define EXPORT_YES true
#define EXPORT_NO false

#define DATA_ADD true
#define DATA_EDIT false

#define HAND_ENABLE true
#define HAND_DISABLE false

enum eTypeCrossword {TYPE_PDF, TYPE_POST_SCRIPT, TYPE_RTF, TYPE_HTML, TYPE_TXT, TYPE_JPG, TYPE_JPEG, TYPE_BMP,
                    TYPE_TIFF, TYPE_PNG, TYPE_XPM, TYPE_XBM, TYPE_PPM, TYPE_OPEN_KLEST};

enum eCheckSaved {SLOT_CLOSE, SLOT_CREATE, SLOT_OPEN, SLOT_EXIT_PROGRAM};
enum eCallSlotsTypes {DATA_TO_CROSSWORD, S_CLOSE};
enum eCellType {CELL_BACK, CELL_BLACK, CELL_LIME, CELL_BACK_FILL};

#endif // CONST_H
